<?php

/*
 * deleteuser.php
 * this will accept a user_id from the user who pushed the "reset" button.
 * The user's name and ID will be deleted from the database.
 * However, first, all games this user had will be set to 
 * complete and any challenges existing from or to this user
 * deleted as well.
 *
 * 02/29/2012 - deleteuser added v1.003 to ensure games are set to complete
 *              and challenges deleted before deleting name
 */


include_once 'DBConnect.php';

$json = $_SERVER['HTTP_JSON'];
$data = json_decode($json);

$user_id = $data->user_id;

// delete any challenges to or from this user 
$query = sprintf("DELETE FROM challenges WHERE challenged ='%s' OR challenger = '%s' ",
    mysql_real_escape_string($user_id),
    mysql_real_escape_string($user_id));
        
// Perform Query
$result = mysql_query($query);

// Check result
// This shows the actual query sent to MySQL, and the error. Useful for debugging.
if (!$result) {
    $message  = 'Invalid query: ' . mysql_error() . "\n";
    $message .= 'Error query: ' . $query;
    die($message);
}

// set any games played to complete
$query = sprintf("UPDATE games SET complete='1', who='%s', last_play_tile='-1', last_tile_score='0' 
          WHERE player1='%s' OR player2='%s' ",
         mysql_real_escape_string($user_id),
         mysql_real_escape_string($user_id),
         mysql_real_escape_string($user_id));
         // Perform Query
$result = mysql_query($query);

// Check result
// This shows the actual query sent to MySQL, and the error. Useful for debugging.
if (!$result) {
    $message  = 'Invalid query: ' . mysql_error() . "\n";
    $message .= 'Error query: ' . $query;
    die($message);
}

// finally, delete this user
$query = sprintf("DELETE FROM user WHERE _id ='%s' ",
    mysql_real_escape_string($user_id));
        
// Perform Query
$result = mysql_query($query);

// Check result
// This shows the actual query sent to MySQL, and the error. Useful for debugging.
if (!$result) {
    $message  = 'Invalid query: ' . mysql_error() . "\n";
    $message .= 'Error query: ' . $query;
    die($message);
}

?>