<?php
/*
 * gamechallege.php
 * 
 * this file accepts a challenge request from user 'username'
 * and userid. The challenging user supplies along with it his own name/id
 * either a username the player wishes to challenge
 * or the keyword "_random_player"
 * 
 * a new game is created and players are added to the game
 * a set of tiles are created, shuffled and the first nine
 * tiles are given to player 1 (the challenger)
 * 
 * the unique game  ID indentifying this game is sent
 * back to player1. If the opponent was a random selection
 * return the user's name
 */
include_once 'DBConnect.php';

$json = $_SERVER['HTTP_JSON'];
$data = json_decode($json);

$username = $data->username;
$user1_id = $data->user_id;




// get requested opponent's name from JSON struct
$username2 = $data->username2;
$nameErr = -1;

//echo $username, $username2, $user1_id;


if ($username2 == "_random_player") {
    // select a player at random from the user table
    $query = sprintf("SELECT _id FROM user  WHERE _id <>'%s' ",  //anyone but player1
    mysql_real_escape_string($user1_id));
    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error damn query: ' . $query;
        die($message);
    }

    // returned list of all user ids except player1's id
    $opponents = array();
    $i =0;
    while ($row = mysql_fetch_assoc($result)) {
        $opponents[$i] = $row['_id'];
        $i++;
    }
    shuffle($opponents);
    // take the first one
    $user2_id = $opponents[0];
    
    //now get the name
    $query = sprintf("SELECT username FROM user WHERE _id='%s'",  
    mysql_real_escape_string($user2_id));
    $result = mysql_query($query);
        // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid stupid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
        $nameErr = 1;
    }
    while ($row = mysql_fetch_assoc($result)) {
      $player2name =  $row['username'];
    }
    
 
}
else { // not random, specific username

    
    $query = sprintf("SELECT * FROM user  WHERE username='%s' " ,
        mysql_real_escape_string($username2));


    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid  query: ' . mysql_error() . "\n";
        $message .= 'Error  query: ' . $query;
        die($message);
    }

    // Use result
    $user2_id = -1;
    while ($row = mysql_fetch_assoc($result)) {
        $user2_id =  $row['_id'];
    }
    if ($user2_id == -1) {
        echo "Error - username ",$username2," does not exist";
        $nameErr = 1;
    }

    $player2name = $username2;
}

//echo "\n";
//echo $player2name, $nameErr;


//echo "name=",$player2name, "nameErr=",$nameErr;
if ($nameErr < 0) {
   // now that we have valid name for player2, let's make a game!
   // create tiles merely indices to the 56 triangles
    $tiles = array();
    for ($i = 0; $i < 56; $i++) {
       $tiles[$i] = $i; 
    }

    shuffle($tiles);
    $p1tiles = array();
    // pull off first 9 tiles for  player1
    for($t = 0; $t < 9; $t++ ){
            $p1tiles[$t] = $tiles[$t];
    }

    // put remaining tiles into the bone pile as a
    // comma-separated string
    $bonestemp = "";
    for($t = 9; $t < 56; $t++ ){
            $bonestemp .= strval($tiles[$t]) . ",";
    }
    // Delete the last character from the string.
    $bones = substr($bonestemp, 0, -1);


    // insert data into the games table
    $result = mysql_query("INSERT INTO games
            (player1, player2, bones, last_play_tile)
            VALUES ('$user1_id', '$user2_id', '$bones', -1 )"
            ) ;
    $new_Game_id = mysql_insert_id();
    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error  query: ' . $query;
        die($message);
    }


    // insert into the challenges table
    $result = mysql_query("INSERT INTO challenges
            (game_id, challenger, ch_name, challenged)
            VALUES('$new_Game_id', '$user1_id', '$username', '$user2_id' )"
            );


    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error  query: ' . $query;
        die($message);
    }
    $score = 0;



    echo " { \"game_id\": ",$new_Game_id,
              ", \"player2\": \"",$player2name, "\"  ";
    echo      ", \"user2_id\": \"",$user2_id, "\" , ";
    echo " \"tiles\" :" , json_encode($p1tiles);
    echo " }";

    //$jdata = array("game_id"=>$new_Game_id, "player2"=>$player2name,
    //        "user2_id"=>$user2_id, )
   
}
    
?>
