<?php

/*
 * passplay.php
 * 
 * this file is invoked when a user cannot play a tile.
 *  the game id and userid is required as input.
 * 
 * a new tile, if available, is selected from the bone
 * pile and given to the requesting player. The bone pile
 * is updated and the user's score is updated. 
 * 
 * taking a tile from the bone pile affects the score
 * by decrement of 5
 */
include_once 'DBConnect.php';
$score = -5;
$json = $_SERVER['HTTP_JSON'];
$data = json_decode($json);

$game_id = $data->game_id;
$userid = $data->user_id;

// Formulate Query
$query = sprintf("SELECT bones FROM games  WHERE _id='%s' ",
    mysql_real_escape_string($game_id));

// Perform Query
$result = mysql_query($query);

// Check result
// This shows the actual query sent to MySQL, and the error. Useful for debugging.
if (!$result) {
    $message  = 'Error Invalid query: ' . mysql_error() . "\n";
    $message .= 'Error query: ' . $query;
    die($message);
}

while ($row = mysql_fetch_assoc($result)) {
    $bones =  $row['bones'];

}

if (strlen($bones) > 0) {
    $delim = ',';
    $pos = strpos($bones, $delim);
    if ($pos == false) {
        // only one number and no commas between it and subsequent. Convert it
        $return_bone = intval($bones);
        $newbones = "";
    }
    else {
        $return_bone = substr($bones, 0, $pos);

        // more than one tile left in the bone pile. strip this one off 
        $newbones = substr($bones, $pos+1);
    }


    
    $query = sprintf("SELECT  player1, player1score, player2, player2score FROM games
            WHERE _id='%s'",
    mysql_real_escape_string($game_id));
    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
    }
    while ($row = mysql_fetch_assoc($result)) {
    $p1 =  $row['player1'];
    $p2 =  $row['player2'];
    $p1score = $row['player1score'];
    $p2score = $row['player2score'];
    }

    if ($user_id == $p1) {
        $p1score += $score;
    }
    else {
        $p2score += $score;
    }
    
    // Formulate Query
    $query = sprintf("UPDATE games SET bones='%s', player1score='%s', player2score='%s', 
        who='%s', last_tile_score='%s', last_play_tile='-1' WHERE _id='%s'",
	mysql_real_escape_string($newbones),
        mysql_real_escape_string($p1score),
        mysql_real_escape_string($p2score),
	mysql_real_escape_string($userid),
        mysql_real_escape_string($score),
        mysql_real_escape_string($game_id));
    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
    }
    
    $jdata = array("bone"=>$return_bone, "score"=>$score);
    echo json_encode($jdata);
    
}
else {
    $score = 0;
    // Formulate Query
    $query = sprintf("UPDATE games SET who='%s', last_play_tile='-1' WHERE _id='%s'",
	
	mysql_real_escape_string($userid),
        mysql_real_escape_string($game_id));
    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
    }
       // no tiles. no change in score
    echo "Error: no tiles left";
}
?>
