package com.ulsanonline.triominoes;

import java.util.ArrayList;

import android.graphics.Point;

public class BoardClass {

	private Point pixelLoc;     // x,y space on the screen
	private Point boardLoc;       // c, r space in the hex grid
	public int vertices[];      // score values for the 3 vertices of this triangle
	public Boolean facedown;        // this triangle either faces up or down
	public Boolean occupied;    // this triangle is either occupied by a tile or not
	public int index;           // a pointer to which grid item this is in an array
	public int tileIndex;          // index of the tile that occupies this grid
	public float setScale;
	// constructor
	public BoardClass () {
		vertices = new int[3];
		boardLoc = new Point();
		pixelLoc = new Point();
		index = -1;
		facedown = false;
		occupied = false;
	}
	/*
	 * public methods for BoardClass
	 */
    public int getBoardCol (){
    	return boardLoc.x;
    }
    
    public int getBoardRow (){
    	return boardLoc.y;
    }
    
    public int getPixelX() {
    	return pixelLoc.x;
    }
    
    public int getPixelY() {
    	return pixelLoc.y;
    }
    
    void setPixelLoc(float sx, float sy) {
    	pixelLoc.x = (int)sx;
    	pixelLoc.y = (int)sy;
    }
    
    void setBoardLoc(int col, int row) {
    	boardLoc.x = col;
    	boardLoc.y = row;
    }
    
    public Boolean isfaceDown() {
    	return facedown;
    }
    
    void setDown (Boolean isdown) {
    	facedown = isdown;
    }
    
    public Boolean isOccupied() {
    	return occupied;
    }
    
    void setOccupied (Boolean isoccupied) {
    	occupied = isoccupied;
    }
       
    void setIndex(int newvalue){
    	index = newvalue;
    }

    public int getTile() {
    	return tileIndex;
    }
    
    void setTileIndex(int newvalue){
    	tileIndex = newvalue;
    }
    
    

}