<?php

/*
 * gameaccept.php
 * 
 * this file presents player 2 with a challenge 
 * request from player 1
 * 
 * require inputs: game_id, player1_id and player2_id
 * 
 * when accepted, player 2 is given the next nine tiles
 * from the bone pile which is then updated to reflect the
 * bone pile status
 * player 2 is also given the unique game ID created when 
 * player 1 created the challenge
 */
include_once 'DBConnect.php';

$json = $_SERVER['HTTP_JSON'];
$data = json_decode($json);

$user1_id = $data->user1_id;  //initiator
$user2_id = $data->user2_id;  // acceptor
$game_id = $data->game_id;

// verify this game exists by query

$query = sprintf("SELECT * FROM challenges 
   WHERE game_id ='%s'  AND challenger = '%s' AND challenged='%s' ",
    mysql_real_escape_string($game_id),
    mysql_real_escape_string($user1_id),
    mysql_real_escape_string($user2_id));
        
// Perform Query
$result = mysql_query($query);

// Check result
// This shows the actual query sent to MySQL, and the error. Useful for debugging.
if (!$result) {
    $message  = 'Invalid query: ' . mysql_error() . "\n";
    $message .= 'Error query: ' . $query;
    die($message);
}
// Use result
$new_id = -1;
while ($row = mysql_fetch_assoc($result)) {
    $new_id = $row['game_id'];
    
}
if ($new_id == -1) {
    echo " Error challenge does not exist";
}
else {
    // delete this challenge and give back the tiles to the device
    $query = sprintf("DELETE FROM challenges  
    WHERE game_id ='%s'  AND challenger = '%s' AND challenged='%s' ",
    mysql_real_escape_string($game_id),
    mysql_real_escape_string($user1_id),
    mysql_real_escape_string($user2_id));
        
    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
    }
    
    // now pull off 9 tiles from the game's bone pile
    $query = sprintf("SELECT * FROM games  
    WHERE _id ='%s'  AND player1 = '%s' AND player2='%s'",
    mysql_real_escape_string($game_id),
    mysql_real_escape_string($user1_id),
    mysql_real_escape_string($user2_id));

    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
    }
    while ($row = mysql_fetch_assoc($result)) {
    $bones =  $row['bones'];
    }

    $splitbones = explode(",", $bones);  // give me an array of strings
    

    $newbones = array();
    for ($i = 0; $i < 9; $i++) {
        $newbones[$i] = $splitbones[$i];
    }
    
    $remainingbones = "";
    for ($i = 9; $i < count($splitbones); $i++) {
      $remainingbones .= strval($splitbones[$i]) . ",";
    }
    
    // update the game with the new remainbing bone pile
    $query = sprintf("UPDATE games SET bones='%s' 
        WHERE _id ='%s'  AND player1 = '%s' AND player2='%s'",
        mysql_real_escape_string($remainingbones),
        mysql_real_escape_string($game_id),
        mysql_real_escape_string($user1_id),
        mysql_real_escape_string($user2_id));
    // Perform Query
    $result = mysql_query($query);

    // Check result
    // This shows the actual query sent to MySQL, and the error. Useful for debugging.
    if (!$result) {
        $message  = 'Invalid query: ' . mysql_error() . "\n";
        $message .= 'Error query: ' . $query;
        die($message);
    }
    
    
    // send back JSON Struct
    echo " { \"game_id\": ",$game_id;
    echo ", \"tiles\" :" , json_encode($newbones);
    echo " }";
}

?>
